![Musare](frontend/dist/assets/blue_wordmark.png)

# Musare

Musare is an open-source collaborative music listening and catalogue curation application. Currently supporting YouTube based content.

A production demonstration instance of Musare can be found at [demo.musare.com](https://demo.musare.com).

---

## Documentation
- [Installation](./.wiki/Installation.md)
- [Upgrading](./.wiki/Upgrading.md)
- [Configuration](./.wiki/Configuration.md)
- [Utility Script](./.wiki/Utility_Script.md)
- [Backend Commands](./.wiki/Backend_Commands.md)
- [Technical Overview](./.wiki/Technical_Overview.md)
- [Value Formats](./.wiki/Value_Formats.md)

---

## Features
- **Playlists**
    - User created playlists
    - Automatically generated playlists for genres
    - Privacy configuration
    - Liked and Disliked songs playlists per user
    - Bulk import songs from YouTube playlist
    - Add songs from verified catalogue or YouTube
    - Ability to download in JSON format
- **Stations**
    - Playlist mode to listen to selected playlists
    - Party mode to allow other users to add songs to queue
    - Ability to blacklist playlists to prevent songs within from playing
    - Themes
    - Privacy configuration
    - Favoriting
    - Official stations controlled by admins (playlist mode only)
    - User created and controlled stations
    - Pause playback just in local session
    - Station-wide pausing by admins or owners
    - Vote to skip songs
    - Force skipping song by admins or owners
    - Add songs to queue from verified catalogue or YouTube (party mode only)
- **Song Management**
    - Verify songs to allow them to be searched for and played in official stations
    - Import Album to import songs in bulk
    - Discogs integration to import metadata
    - Ability for users to report issues with songs and admins to resolve
    - Configurable skip duration and song duration to cut intros and outros
    - Import YouTube playlists from admin area
    - Any song added to playlists or stations will be automatically requested
    - Bulk admin management of songs
    - Create songs from scratch
- **Users**
    - Activity logs
    - Profile page showing public playlists and activity logs
    - Text or gravatar profile pictures
    - Email or Github login/registration
    - Preferences to tailor site usage
    - Password reset
    - Data deletion management
    - ActivityWatch integration
- **Punishments**
    - Ban users
    - Ban IPs
- **News**
    - Admins can add/edit/remove news items
    - Markdown editor
- **Night Mode**
- **Administration**
    - Admin area to manage instance
    - Configurable data tables
        - Reorder, resize, sort by and toggle visibilty of columns
        - Advanced queries
    - Bulk management
    - View backend statistics
---

## Contact

Get in touch with us via email at [core@musare.com](mailto:core@musare.com).
